
<!doctype html>
<html lang="en">




<head>
    <title>How to WinPE Kickstart Win2016+oVirt - Attune Automation</title>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport"
          content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="title"
          content="How to WinPE Kickstart Win2016+oVirt - Attune Automation">
    <meta name="description"
          content="">
    <meta name="robots"
          content="follow, index, max-snippet:-1, max-video-preview:-1, max-image-preview:large">

    <meta property="og:locale" content="en_AU" />
    <meta property="og:type" content="article" />
    <meta property="og:title"
          content="HowTo WinPE Kickstart Win2016+oVirt - Attune Automation" />
    <meta property="og:description" content="" />
    <meta property="og:site_name" content="Attune Automation" />
    <meta property="article:section" content="IT Instruction" />

    <meta name="twitter:title"
          content="How to WinPE Kickstart Win2016+oVirt - Attune Automation" />
    <meta name="twitter:description" content="" />

    <link rel="icon" href="https://www.servertribe.com/wp-content/uploads/2020/10/cropped-server_tribe_favicon-32x32.png" sizes="32x32">
    <link rel="icon" href="https://www.servertribe.com/wp-content/uploads/2020/10/cropped-server_tribe_favicon-192x192.png" sizes="192x192">
    <link rel="apple-touch-icon" href="https://www.servertribe.com/wp-content/uploads/2020/10/cropped-server_tribe_favicon-180x180.png">
    <meta name="msapplication-TileImage" content="https://www.servertribe.com/wp-content/uploads/2020/10/cropped-server_tribe_favicon-270x270.png">
    <link rel="stylesheet"
          href="https://cdn.jsdelivr.net/npm/bootstrap@4.0.0/dist/css/bootstrap.min.css"
          integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm"
          crossorigin="anonymous">
    <link rel="stylesheet"
          href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css">
    <link rel="stylesheet"
          href="https://cdnjs.cloudflare.com/ajax/libs/prism/1.29.0/themes/prism-tomorrow.min.css">
    <link rel="stylesheet" href="../styles/style.css">

</head>


<body>

<!-- Project breadcrumbs -->

<!-- Project breadcrumbs -->
<nav aria-label="breadcrumb">
    <ol class="breadcrumb m-0">
        <li class="breadcrumb-item" aria-current="page">
            <a
                href="https://www.servertribe.com/"
                target="_blank">
                ServerTribe
            </a>
        </li>
        <li class="breadcrumb-item" aria-current="page">
            <a
                href="https://github.com/attune-Automation/"
                target="_blank">
                Attune Automation Projects
            </a>
        </li>
        <li class="breadcrumb-item">
            <a href="../index.html">
            Kickstart Windows
            </a>
        </li>
        <li class="breadcrumb-item active" aria-current="page">
            <strong>WinPE Kickstart Win2016+oVirt</strong>
        </li>
    </ol>
</nav>

<!-- Blueprint Header -->

<div class="container px-0">
    <!-- Blueprint name and description -->
    <div class="row pt-5">
        <div class="col px-0">
            <h1 class="text-left">
                How to WinPE Kickstart Win2016+oVirt
            </h1>
        </div>
    </div>

<!-- Blueprint Description -->
    <div class="row pt-4">
        <div class="col-6 px-0">
            <h6 class="text-left">
                This documentation is generated by
                <a href="https://www.servertribe.com/"
                    class="badge badge-primary"
                    target="_blank">
                    Attune
                </a>
            </h6>
        </div>
        <div class="col-6 align-self-end text-right px-0">
            <h6 class="text-right">
                <a href="https://www.youtube.com/@servertribe"
                    class="badge badge-secondary"
                    target="_blank">
                    YouTube
                </a>
                <a href="https://github.com/Attune-Automation"
                    class="badge badge-secondary"
                    target="_blank">
                    GitHub
                </a>
                <a href="https://discord.com/invite/3YpJsagqUn"
                    class="badge badge-secondary"
                    target="_blank">
                    Discord
                </a>
                <a href="https://www.linkedin.com/company/servertribe/"
                    class="badge badge-secondary"
                    target="_blank">
                    LinkedIn
                </a>
                <a href="http://doc.servertribe.com/"
                    class="badge badge-secondary"
                    target="_blank">
                    Documentation
                </a>
            </h6>
        </div>
    </div>
    <hr>
</div>

<div class="documentation">
    <div class="container px-0">
        <div class="row">

<!-- Blueprint ToC -->


            <div class="col-lg-2 px-0 pr-5">
                <div class="container px-0 pt-3 sticky-top">
                    <h6 class="pb-2">
                        <strong>Contents</strong>
                    </h6>
                    <h6 class="text-muted">
                        <a href="#top">
                            <strong>WinPE Kickstart Win2016+oVirt</strong>
                        </a>
                    </h6>


    
        

                    <h6 class="text-muted pt-2">
                        <a href="#kscleanbuildfiles">
                            <strong>Step 1 -</strong> KS Clean Build Files
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#kswin10deploywinpeisoovirt">
                            <strong>Step 2 -</strong> KS Win10 Deploy WinPE ISO oVirt
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksextractwinpeiso">
                            <strong>Step 3 -</strong> KS Extract WinPE ISO
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksextractwinpebootimg">
                            <strong>Step 4 -</strong> KS Extract WinPE boot.img
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksmovebootimgtoextractedwinpefolder">
                            <strong>Step 5 -</strong> KS Move boot.img to Extracted WinPE Folder
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksovirtdeployovirtdrivers">
                            <strong>Step 6 -</strong> KS oVirt Deploy oVirt Drivers
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksmoveovirtdriverstoextractedwinpefolder">
                            <strong>Step 7 -</strong> KS Move oVirt Drivers to Extracted WinPE Folder
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksovirtwin2019deployunattendedconfig">
                            <strong>Step 8 -</strong> KS oVirt Win2019 Deploy Unattended Config
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksmoveautounattendxmltoextractedwinpefolder">
                            <strong>Step 9 -</strong> KS Move Autounattend.xml to Extracted WinPE Folder
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#modifywinpebootwim">
                            <strong>Step 10 -</strong> Modify WinPE boot.wim
                        </a>
                    </h6>
    
        

                    <h6 class="text-muted pt-2">
                        <a href="#createbootwimmountdirectory">
                            <strong>Step 10.1 -</strong> Create boot.wim Mount Directory
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#wimlibmountbootwim">
                            <strong>Step 10.2 -</strong> wimlib Mount boot.wim
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#pushstartnetcmd">
                            <strong>Step 10.3 -</strong> Push startnet.cmd
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#mwbprintstartnetcmd">
                            <strong>Step 10.4 -</strong> MWB Print startnet.cmd
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#wimlibunmountbootwim">
                            <strong>Step 10.5 -</strong> wimlib Unmount boot.wim
                        </a>
                    </h6>


        

                    <h6 class="text-muted pt-2">
                        <a href="#kswcbiwinpecreatebootiso">
                            <strong>Step 11 -</strong> KSWCBI WinPE Create Boot ISO
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksovirtrecreatevirtualmachinecleanup">
                            <strong>Step 12 -</strong> KS oVirt Recreate Virtual Machine - Cleanup
                        </a>
                    </h6>
    
        

                    <h6 class="text-muted pt-2">
                        <a href="#ksovirtunloadisofromvm">
                            <strong>Step 12.1 -</strong> KS oVirt Unload ISO from VM
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksovirtdeletefloatingisodisk">
                            <strong>Step 12.2 -</strong> KS oVirt Delete Floating ISO Disk
                        </a>
                    </h6>


        

                    <h6 class="text-muted pt-2">
                        <a href="#ksovirtbootwinperecreatevirtualmachine">
                            <strong>Step 13 -</strong> KS oVirt Boot WinPE Recreate Virtual Machine
                        </a>
                    </h6>
    
        

                    <h6 class="text-muted pt-2">
                        <a href="#ksovirtdeletevm">
                            <strong>Step 13.1 -</strong> KS oVirt Delete VM
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksovirtcreatevm">
                            <strong>Step 13.2 -</strong> KS oVirt Create VM
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksovirtaddosdisk">
                            <strong>Step 13.3 -</strong> KS oVirt Add OS Disk
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksovirtaddnic">
                            <strong>Step 13.4 -</strong> KS oVirt Add NIC
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksovirtaddfloatingisodisk">
                            <strong>Step 13.5 -</strong> KS oVirt Add Floating ISO Disk
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksovirtimagelotransferisotofloatingdisk">
                            <strong>Step 13.6 -</strong> KS oVirt ImagelO Transfer ISO To Floating Disk
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksovirtloaddatastorageisointovm">
                            <strong>Step 13.7 -</strong> KS oVirt Load Data Storage ISO into VM
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksovirtboottoiso">
                            <strong>Step 13.8 -</strong> KS oVirt Boot to ISO
                        </a>
                    </h6>


        

                    <h6 class="text-muted pt-2">
                        <a href="#kswinwinrmhttpswait120s">
                            <strong>Step 14 -</strong> KS Win WinRM HTTPS Wait 120s
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksovirtrecreatevirtualmachinecleanup">
                            <strong>Step 15 -</strong> KS oVirt Recreate Virtual Machine - Cleanup
                        </a>
                    </h6>
    
        

                    <h6 class="text-muted pt-2">
                        <a href="#ksovirtunloadisofromvm">
                            <strong>Step 15.1 -</strong> KS oVirt Unload ISO from VM
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksovirtdeletefloatingisodisk">
                            <strong>Step 15.2 -</strong> KS oVirt Delete Floating ISO Disk
                        </a>
                    </h6>


        

                    <h6 class="text-muted pt-2">
                        <a href="#kscleanbuildfiles">
                            <strong>Step 16 -</strong> KS Clean Build Files
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#installovirtguestadditionslink">
                            <strong>Step 17 -</strong> Install oVirt Guest Additions (Link)
                        </a>
                    </h6>


                </div>
            </div>

<!-- Blueprint Contents -->
            <div class="col-lg-8 pt-3">
                <div class="container">


        <div class="blueprint-description jumbotron">
            <h2 class="display-3 text-center">
                Automate This
            </h2>
            <p class="lead text-center">
                Use the <strong>Attune GUI</strong> for your Scripts
            </p>
            <p class="lead">
                <ol>
                    <a href="https://www.servertribe.com/download-attune-registration/"
                        target="_blank">
                        <span class="badge badge-primary">1</span>
                        Download Attune
                        <i class="fa-solid fa-download fa-beat-fade" style="color: #0197ff;"></i>
                    </a>
                </ol>
                <ol>
                    <a href="https://github.com/attune-Automation/"
                        target="_blank">
                        <span class="badge badge-primary">2</span>
                         Copy the Attune Project URL
                         <i class="fa-brands fa-github fa-fade"></i>
                    </a>
                </ol>
                <ol>
                    <a href="https://servertribe-attune.readthedocs.io/en/latest/howto/design_workspace/clone_project.html"
                        target="_blank">
                        <span class="badge badge-primary">3</span>
                        Clone the Project in Attune
                         <i class="fa-solid fa-book fa-fade" style="color: #0197ff;"></i>
                    </a>
                </ol>
                <ol>
                    <a href="https://www.youtube.com/watch?v=GCWDI29rDV0"
                        target="_blank">
                        <span class="badge badge-primary">4</span>
                        Plan your Job(s)
                        <i class="fa-brands fa-youtube fa-fade" style="color: #0197ff;"></i>
                    </a>
                </ol>
                <ol>
                    <a href="https://www.youtube.com/watch?v=b7DhFcURkZg"
                        target="_blank">
                        <span class="badge badge-primary">5</span>
                        Run your Job(s)
                        <i class="fa-brands fa-youtube fa-fade" style="color: #0197ff;"></i>
                    </a>
                </ol>
            </p>
            <p class="lead text-center">
                You've automated: <strong>WinPE Kickstart Win2016+oVirt</strong>
            </p>
            <hr class="my-4 text-center">
            <div class="col px-0">
                <p class="text-center">
                    Get the most out of automation with our get started
                    videos, product demonstrations, and more.
                </p>
                <p class="lead text-center">
                    <a class="btn btn-primary btn-lg"
                       href="https://www.servertribe.com/learn/"
                       target="_blank"
                       role="button">
                        Learn Attune Automation
                    </a>
                </p>
            </div>
        </div>

        <div class="row">
            <p>The following steps will guide you through the manual process.</p>
        </div>

<!-- Blueprint Steps -->


        



                    <div class="row pt-5">
                        <h4 id="kscleanbuildfiles">
                            <a href="#kscleanbuildfiles">
                                <strong>Step 1 -</strong> KS Clean Build Files
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>










                        <div class="row">
                            <p>
                                Connect via ssh:
                            </p>
                        </div>
                        <div class="row py-1">
                            <code class="language-sql">
ssh {linuxattuneuser}@{attuneosbuildserver}
                            </code>
                        </div>



    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
DIR=&quot;{ksVmwareAttuneBaseDir}/build-{targetServer.fqn}&quot;
[[ -d ${DIR} ]] &amp;&amp; rm -rf ${DIR} &amp;&amp; echo &quot;Removed ${DIR}&quot; || \
    echo &quot;No directory to remove.&quot;

ISO=&quot;{ksVmwareAttuneBaseDir}/kickstart_{targetServer.fqn}.iso&quot;
[[ -f ${ISO} ]] &amp;&amp; rm -fv ${ISO} || echo &quot;No ISO to remove.&quot;
                </code>
            </pre>
        </div>
    </div>





        



                    <div class="row pt-5">
                        <h4 id="kswin10deploywinpeisoovirt">
                            <a href="#kswin10deploywinpeisoovirt">
                                <strong>Step 2 -</strong> KS Win10 Deploy WinPE ISO oVirt
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    

    



    <div class="row">
        <p>
            
        </p>
        <p>
            Copy the File(s)
            <strong>WinPE_ISO_for_oVirt_0Jan2023.zip</strong>
            to the target node.
        </p>
        <p>
            <strong>Extract and deploy the File(s)</strong> here:
        </p>
    </div>
    <div class="row py-1">
        <code class="language-bash">
{ksVmwareAttuneBaseDir}/build-{targetServer.fqn}, relative to the home directory
        </code>
    </div>





        



                    <div class="row pt-5">
                        <h4 id="ksextractwinpeiso">
                            <a href="#ksextractwinpeiso">
                                <strong>Step 3 -</strong> KS Extract WinPE ISO
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
cd {ksVmwareAttuneBaseDir}/build-{targetServer.fqn}

mkdir -p WinPE_amd64Dir

iso_file=$(ls *.iso)

7z x $iso_file -oWinPE_amd64Dir
                </code>
            </pre>
        </div>
    </div>





        



                    <div class="row pt-5">
                        <h4 id="ksextractwinpebootimg">
                            <a href="#ksextractwinpebootimg">
                                <strong>Step 4 -</strong> KS Extract WinPE boot.img
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
# Extract the boot.img out of the WinPE ISO

cd {ksVmwareAttuneBaseDir}/build-{targetServer.fqn}

# Set the filename of the ISO
F=$(ls *.iso)

# Get the Boot image offset
OFFSET=`isoinfo -d -i $F | grep Bootoff | cut  -c21-`

# Extract the boot.img.
dd if=$F of=boot.img bs=2048 count=8 skip=$OFFSET
                </code>
            </pre>
        </div>
    </div>





        



                    <div class="row pt-5">
                        <h4 id="ksmovebootimgtoextractedwinpefolder">
                            <a href="#ksmovebootimgtoextractedwinpefolder">
                                <strong>Step 5 -</strong> KS Move boot.img to Extracted WinPE Folder
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
cd {ksVmwareAttuneBaseDir}/build-{targetServer.fqn}

mv boot.img WinPE_amd64Dir
                </code>
            </pre>
        </div>
    </div>





        



                    <div class="row pt-5">
                        <h4 id="ksovirtdeployovirtdrivers">
                            <a href="#ksovirtdeployovirtdrivers">
                                <strong>Step 6 -</strong> KS oVirt Deploy oVirt Drivers
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            <p>Works for both Windows 2019 and Windows 10.</p>
                        </p>
                    </div>









    

    



    <div class="row">
        <p>
            
        </p>
        <p>
            Copy the File(s)
            <strong>oVirt_Drivers_0Jan2023.zip</strong>
            to the target node.
        </p>
        <p>
            <strong>Extract and deploy the File(s)</strong> here:
        </p>
    </div>
    <div class="row py-1">
        <code class="language-bash">
{ksVmwareAttuneBaseDir}/build-{targetServer.fqn}, relative to the home directory
        </code>
    </div>





        



                    <div class="row pt-5">
                        <h4 id="ksmoveovirtdriverstoextractedwinpefolder">
                            <a href="#ksmoveovirtdriverstoextractedwinpefolder">
                                <strong>Step 7 -</strong> KS Move oVirt Drivers to Extracted WinPE Folder
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
cd {ksVmwareAttuneBaseDir}/build-{targetServer.fqn}

mv Drivers WinPE_amd64Dir
                </code>
            </pre>
        </div>
    </div>





        



                    <div class="row pt-5">
                        <h4 id="ksovirtwin2019deployunattendedconfig">
                            <a href="#ksovirtwin2019deployunattendedconfig">
                                <strong>Step 8 -</strong> KS oVirt Win2019 Deploy Unattended Config
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    

    



    <div class="row">
        <p>
            
        </p>
        <p>
            Copy the File(s)
            <strong>WIN_Win201_Unattended_Config_with_Drivers.tar</strong>
            to the target node.
        </p>
        <p>
        </p>
    </div>
    <div class="row py-1">
        <code class="language-bash">
{ksVmwareAttuneBaseDir}/build-{targetServer.fqn}, relative to the home directory
        </code>
    </div>





        



                    <div class="row pt-5">
                        <h4 id="ksmoveautounattendxmltoextractedwinpefolder">
                            <a href="#ksmoveautounattendxmltoextractedwinpefolder">
                                <strong>Step 9 -</strong> KS Move Autounattend.xml to Extracted WinPE Folder
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
cd {ksVmwareAttuneBaseDir}/build-{targetServer.fqn}

mv autounattend.xml WinPE_amd64Dir
                </code>
            </pre>
        </div>
    </div>





        



                    <div class="row pt-5">
                        <h3 id="modifywinpebootwim">
                            <a href="#modifywinpebootwim">
                                <strong>Step 10 -</strong> Modify WinPE boot.wim
                            </a>
                        </h3>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>





    




    



                    <div class="row pt-5">
                        <h4 id="createbootwimmountdirectory">
                            <a href="#createbootwimmountdirectory">
                                <strong>Step 10.1 -</strong> Create boot.wim Mount Directory
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
cd {ksVmwareAttuneBaseDir}/build-{targetServer.fqn}

WinPE_BootImageDir=&quot;WinPE_BootImageDir&quot;
if [ ! -d WinPE_BootImageDir ]
then
    mkdir $WinPE_BootImageDir
fi
                </code>
            </pre>
        </div>
    </div>





    



                    <div class="row pt-5">
                        <h4 id="wimlibmountbootwim">
                            <a href="#wimlibmountbootwim">
                                <strong>Step 10.2 -</strong> wimlib Mount boot.wim
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
cd {ksVmwareAttuneBaseDir}/build-{targetServer.fqn}
wimmountrw WinPE_amd64Dir/sources/boot.wim WinPE_BootImageDir
                </code>
            </pre>
        </div>
    </div>





    



                    <div class="row pt-5">
                        <h4 id="pushstartnetcmd">
                            <a href="#pushstartnetcmd">
                                <strong>Step 10.3 -</strong> Push startnet.cmd
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    

    



    <div class="row">
        <p>
            
        </p>
        <p>
            Copy the File(s)
            <strong>WinPE_startnetcmd_for_Win10.tar</strong>
            to the target node.
        </p>
        <p>
        </p>
    </div>
    <div class="row py-1">
        <code class="language-bash">
{ksVmwareAttuneBaseDir}/build-{targetServer.fqn}/WinPE_BootImageDir/Windows/System32, relative to the home directory
        </code>
    </div>





    



                    <div class="row pt-5">
                        <h4 id="mwbprintstartnetcmd">
                            <a href="#mwbprintstartnetcmd">
                                <strong>Step 10.4 -</strong> MWB Print startnet.cmd
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            <p>This is useful for debugging WinPE issues.</p>
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
cd {ksVmwareAttuneBaseDir}/build-{targetServer.fqn}/WinPE_BootImageDir/Windows/System32
cat startnet.cmd
                </code>
            </pre>
        </div>
    </div>





    



                    <div class="row pt-5">
                        <h4 id="wimlibunmountbootwim">
                            <a href="#wimlibunmountbootwim">
                                <strong>Step 10.5 -</strong> wimlib Unmount boot.wim
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
cd {ksVmwareAttuneBaseDir}/build-{targetServer.fqn}
wimunmount WinPE_BootImageDir --commit --check --rebuild
                </code>
            </pre>
        </div>
    </div>






        



                    <div class="row pt-5">
                        <h4 id="kswcbiwinpecreatebootiso">
                            <a href="#kswcbiwinpecreatebootiso">
                                <strong>Step 11 -</strong> KSWCBI WinPE Create Boot ISO
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
cd {ksVmwareAttuneBaseDir}/build-{targetServer.fqn}/WinPE_amd64Dir

# Create new ISO with answer file, Drivers and Windows install
mkisofs -o {ksVmwareAttuneBaseDir}/kickstart_{targetServer.fqn}.iso \
    -b boot.img -no-emul-boot -c BOOT.CAT \
    -iso-level 2 -udf -joliet-long -relaxed-filenames -allow-limited-size \
    -J -l -D -N -V &quot;KS_WIN&quot; .
                </code>
            </pre>
        </div>
    </div>





        



                    <div class="row pt-5">
                        <h3 id="ksovirtrecreatevirtualmachinecleanup">
                            <a href="#ksovirtrecreatevirtualmachinecleanup">
                                <strong>Step 12 -</strong> KS oVirt Recreate Virtual Machine - Cleanup
                            </a>
                        </h3>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>





    




    



                    <div class="row pt-5">
                        <h4 id="ksovirtunloadisofromvm">
                            <a href="#ksovirtunloadisofromvm">
                                <strong>Step 12.1 -</strong> KS oVirt Unload ISO from VM
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
export PATH=~/ks_ovirt_py_venv/bin:$PATH

python3 &lt;&lt;&quot;EOF&quot;
import logging
import sys

import ovirtsdk4 as sdk
import ovirtsdk4.types as types

logging.basicConfig(stream=sys.stdout, level=logging.INFO)
logger = logging.getLogger(&quot;Attune&quot;)

# This example will connect to the server, search for a VM by name and
# remove it:

# Create the connection to the server:
connection = sdk.Connection(
    url=&#x27;https://{ovirtEngineServer.fqn}/ovirt-engine/api&#x27;,
    username=&#x27;{ovirtEngineApiUser.user}&#x27;,
    password=&#x27;{ovirtEngineApiUser.password}&#x27;,
    insecure=True,
    debug=True,
    log=logger,
)
logger.info(&quot;Connection Successful&quot;)

logger.info(&quot;Getting system_service&quot;)
system_service = connection.system_service()

logger.info(&quot;Getting vms_service&quot;)
vms_service = system_service.vms_service()

# Find the VM:
logger.info(&quot;Searchig for VM &#x27;name={targetServer.fqn}&#x27;&quot;)
vmSearch = vms_service.list(search=&#x27;name={targetServer.fqn}&#x27;)

if not len(vmSearch):
    logger.info(&quot;VM &#x27;name={targetServer.fqn}&#x27; doesn&#x27;t exist, exiting&quot;)
    exit(0)

logger.info(&quot;Found VM &#x27;name={targetServer.fqn}&#x27;&quot;)
vm = vmSearch[0]

logger.info(&quot;Getting VM Service for VM ID=%s&quot; % vm.id)
vm_service = vms_service.vm_service(vm.id)

logger.info(&quot;Get the CDROMS Service&quot;)
cdroms_service = vm_service.cdroms_service()

logger.info(&quot;Get the first CDROM&quot;)
cdrom = cdroms_service.list()[0]

logger.info(&quot;Get the CDROM service for the first drive&quot;)
cdrom_service = cdroms_service.cdrom_service(cdrom.id)


logger.info(&quot;Eject the CDROM on PowerOn&quot;)
cdrom_service.update(
    cdrom=types.Cdrom(
        file=types.File(
            id=&#x27;&#x27;
        ),
    ),
    current=False,
)


logger.info(&quot;Close the connection to the server&quot;)
connection.close()

EOF
                </code>
            </pre>
        </div>
    </div>





    



                    <div class="row pt-5">
                        <h4 id="ksovirtdeletefloatingisodisk">
                            <a href="#ksovirtdeletefloatingisodisk">
                                <strong>Step 12.2 -</strong> KS oVirt Delete Floating ISO Disk
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
export PATH=~/ks_ovirt_py_venv/bin:$PATH

python3 &lt;&lt;&quot;EOF&quot;

import logging
import time
import sys

import ovirt_imageio
from ovirt_imageio import client

import ovirtsdk4 as sdk
import ovirtsdk4.types as types

import os

logging.basicConfig(stream=sys.stdout, level=logging.INFO)
logger = logging.getLogger(&quot;Attune&quot;)

# This example will connect to the server and transfer the ISO

# Create the connection to the server:
connection = sdk.Connection(
    url=&#x27;https://{ovirtEngineServer.fqn}/ovirt-engine/api&#x27;,
    username=&#x27;{ovirtEngineApiUser.user}&#x27;,
    password=&#x27;{ovirtEngineApiUser.password}&#x27;,
    insecure=True,
    debug=True,
    log=logger,
)
logger.info(&quot;Connection Successful&quot;)

logger.info(&quot;Getting system_service&quot;)
system_service = connection.system_service()

logger.info(&quot;Getting vms_service&quot;)
vms_service = system_service.vms_service()

logger.info(&quot;Getting the disks service for the new disk&quot;)
disks_service = system_service.disks_service()

logger.info(&quot;Searchig for VM &#x27;name={targetServer.fqn}&#x27;&quot;)
vmSearch = vms_service.list(search=&#x27;name={targetServer.fqn}&#x27;)

if not len(vmSearch):
    logger.info(&quot;VM &#x27;name={targetServer.fqn}&#x27; doesn&#x27;t exist, exiting&quot;)
    exit(0)

logger.info(&quot;Found VM &#x27;name={targetServer.fqn}&#x27;&quot;)
vm = vmSearch[0]


diskName=&#x27;kickstart_{targetServer.fqn}.iso&#x27;

search_string=&quot;name=%s&quot; % diskName
print(&quot;search_string=%s&quot; % search_string)

logger.info(&quot;Getting the disks service for the new disk&quot;)
disks_service = system_service.disks_service()
disks = disks_service.list(search=search_string)


if not len(disks):
    logger.info(&quot;%s is already deleted.&quot; % diskName)

for disk in disks:
    logger.info(&quot;deleteing disk = %s, id=%s, status=%s&quot; % (disk.name, disk.id, disk.status))
    disk_service = disks_service.disk_service(disk.id)
    disk_service.remove()

EOF
                </code>
            </pre>
        </div>
    </div>






        



                    <div class="row pt-5">
                        <h3 id="ksovirtbootwinperecreatevirtualmachine">
                            <a href="#ksovirtbootwinperecreatevirtualmachine">
                                <strong>Step 13 -</strong> KS oVirt Boot WinPE Recreate Virtual Machine
                            </a>
                        </h3>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>





    




    



                    <div class="row pt-5">
                        <h4 id="ksovirtdeletevm">
                            <a href="#ksovirtdeletevm">
                                <strong>Step 13.1 -</strong> KS oVirt Delete VM
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            <p>https://github.com/oVirt/ovirt-engine-sdk/blob/master/sdk/examples/remove_vm.py</p>
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
export PATH=~/ks_ovirt_py_venv/bin:$PATH

python3 &lt;&lt;&quot;EOF&quot;
import logging
import time
import sys

import ovirtsdk4 as sdk
import ovirtsdk4.types as types

logging.basicConfig(stream=sys.stdout, level=logging.INFO)
logger = logging.getLogger(&quot;Attune&quot;)

# This example will connect to the server, search for a VM by name and
# remove it:

# Create the connection to the server:
connection = sdk.Connection(
    url=&#x27;https://{ovirtEngineServer.fqn}/ovirt-engine/api&#x27;,
    username=&#x27;{ovirtEngineApiUser.user}&#x27;,
    password=&#x27;{ovirtEngineApiUser.password}&#x27;,
#    ca_file=&#x27;ca.pem&#x27;,
    insecure=True,
    debug=True,
    log=logger,
)
logger.info(&quot;Connection Successful&quot;)

# Find the service that manages VMs:
logger.info(&quot;Getting system_service&quot;)
system_service = connection.system_service()

logger.info(&quot;Getting vms_service&quot;)
vms_service = system_service.vms_service()

# Find the VM:
logger.info(&quot;Searchig for VM &#x27;name={targetServer.fqn}&#x27;&quot;)
try:
    vm = vms_service.list(search=&#x27;name={targetServer.fqn}&#x27;)[0]
    
except IndexError:
    logger.info(&quot;VM must not exist yet&quot;)
    exit(0)

# Note that the &quot;vm&quot; variable that we assigned above contains only the
# data of the VM, it doesn&#x27;t have any method like &quot;remove&quot;. Methods are
# defined in the services. So now that we have the description of the VM
# we can find the service that manages it, calling the locator method
# &quot;vm_service&quot; defined in the &quot;vms&quot; service. This locator method
# receives as parameter the identifier of the VM and retursn a reference
# to the service that manages that VM.

logger.info(&quot;Getting VM Service for VM ID=%s&quot; % vm.id)
vm_service = vms_service.vm_service(vm.id)

try:
    logger.info(&quot;Stopping VM&quot;)
    vm_service.stop(async_=False)
    
    # Wait till the virtual machine is down:
    while True:
        time.sleep(5)
        vm = vm_service.get()
        if vm.status == types.VmStatus.DOWN:
            break
    
except:
    logger.info(&quot;VM Must have already been stopped&quot;)
    pass

logger.info(&quot;Deleting VM&quot;)
vm_service.remove(async_=False)

# Close the connection to the server:
connection.close()

EOF
                </code>
            </pre>
        </div>
    </div>





    



                    <div class="row pt-5">
                        <h4 id="ksovirtcreatevm">
                            <a href="#ksovirtcreatevm">
                                <strong>Step 13.2 -</strong> KS oVirt Create VM
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            <p>https://github.com/oVirt/ovirt-engine-sdk/blob/master/sdk/examples/add_vm.py</p>
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
export PATH=~/ks_ovirt_py_venv/bin:$PATH

python3 &lt;&lt;&quot;EOF&quot;
import logging
import sys

import ovirtsdk4 as sdk
import ovirtsdk4.types as types

logging.basicConfig(stream=sys.stdout, level=logging.INFO)
logger = logging.getLogger(&quot;Attune&quot;)

# This example will connect to the server and create a new virtual machine:

# Create the connection to the server:
connection = sdk.Connection(
    url=&#x27;https://{ovirtEngineServer.fqn}/ovirt-engine/api&#x27;,
    username=&#x27;{ovirtEngineApiUser.user}&#x27;,
    password=&#x27;{ovirtEngineApiUser.password}&#x27;,
    insecure=True,
    debug=True,
    log=logger,
)
logger.info(&quot;Connection Successful&quot;)

# Find the service that manages VMs:
logger.info(&quot;Getting system_service&quot;)
system_service = connection.system_service()

logger.info(&quot;Getting vms_service&quot;)
vms_service = system_service.vms_service()

# Use the &quot;add&quot; method to create a new virtual machine:
vms_service.add(
    types.Vm(
        name=&#x27;{targetServer.fqn}&#x27;,
        time_zone=types.TimeZone(name=&quot;{ovirtTimeZone}&quot;),
        cluster=types.Cluster(
            name=&#x27;{ovirtClusterName}&#x27;,
        ),
        template=types.Template(
            name=&#x27;Blank&#x27;,
        ),
        memory={ovirtMemorySize}*1024*1024*1024,
        memory_policy=types.MemoryPolicy(
            ballooning=False,
            guaranteed={ovirtMemorySize}*1024*1024*1024
        ),
        cpu=types.Cpu(
            architecture=types.Architecture.X86_64,
            topology=types.CpuTopology(
                cores={ovirtCpuCount},
                sockets=1,
                threads=1
            )
        ),
        bios=types.Bios (
            type=types.BiosType.{ovirtBiosType}
        )
    ),
)

# Close the connection to the server:
connection.close()
EOF
                </code>
            </pre>
        </div>
    </div>





    



                    <div class="row pt-5">
                        <h4 id="ksovirtaddosdisk">
                            <a href="#ksovirtaddosdisk">
                                <strong>Step 13.3 -</strong> KS oVirt Add OS Disk
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
export PATH=~/ks_ovirt_py_venv/bin:$PATH

python3 &lt;&lt;&quot;EOF&quot;
import logging
import time
import sys

import ovirtsdk4 as sdk
import ovirtsdk4.types as types

logging.basicConfig(stream=sys.stdout, level=logging.INFO)
logger = logging.getLogger(&quot;Attune&quot;)


connection = sdk.Connection(
    url=&#x27;https://{ovirtEngineServer.fqn}/ovirt-engine/api&#x27;,
    username=&#x27;{ovirtEngineApiUser.user}&#x27;,
    password=&#x27;{ovirtEngineApiUser.password}&#x27;,
    insecure=True,
    debug=True,
    log=logger,
)
logger.info(&quot;Connection Successful&quot;)

logger.info(&quot;Getting system_service&quot;)
system_service = connection.system_service()

logger.info(&quot;Getting vms_service&quot;)
vms_service = system_service.vms_service()

logger.info(&quot;Searchig for VM &#x27;name={targetServer.fqn}&#x27;&quot;)
vm = vms_service.list(search=&#x27;name={targetServer.fqn}&#x27;)[0]
logger.info(&quot;Found VM &#x27;name={targetServer.fqn}&#x27;&quot;)

logger.info(&quot;Getting the disk service&quot;)
disk_attachments_service = vms_service.vm_service(vm.id).disk_attachments_service()

diskName=&#x27;{targetServer.fqn}-disk0&#x27;

logger.info(&quot;Attaching the new disk&quot;)
disk_attachment = disk_attachments_service.add(
    types.DiskAttachment(
        disk=types.Disk(
            name=diskName,
            description=&#x27;{targetServer.fqn}-disk0&#x27;,
            format=types.DiskFormat.COW,
            provisioned_size=100 * 2**30,
            storage_domains=[
                types.StorageDomain(
                    name=&#x27;{ovirtDiskStorageName}&#x27;,
                ),
            ],
        ),
        interface=types.DiskInterface.{ovirtDiskInterface},
        bootable=True,
        active=True,
    ),
)

logger.info(&quot;Getting the disks service for the new disk&quot;)
disks_service = connection.system_service().disks_service()

logger.info(&quot;Getting the disk service for the new disk&quot;)
disk_service = disks_service.disk_service(disk_attachment.disk.id)

logger.info(&quot;Starting to wait for disk to become online&quot;)
while True:
    logger.info(&quot;Wait for disk to become online&quot;)
    time.sleep(5)
    disk = disk_service.get()
    if disk.status == types.DiskStatus.OK:
        break

logger.info(&quot;Starting disk to appear&quot;)
while True:
    logger.info(&quot;Getting disk attatchment for %s&quot;, diskName)
    disk_attachments = disk_attachments_service.list(search=&#x27;name=%s&#x27; % diskName)
    if len(disk_attachments):
        break

    logger.info(&quot;Waiting for disk to become online&quot;)
    time.sleep(5)

logger.info(&quot;Wiating for attatchment status&quot;)
while True:
    logger.info(&quot;Getting disk attatchment for %s&quot;, diskName)
    disk = connection.follow_link(disk_attachment.disk)
    
    print(disk.status)
    if disk.status == types.DiskStatus.OK:
        break

    logger.info(&quot;Waiting for disk to attatch&quot;)
    time.sleep(5)

logger.info(&quot;Disk is online and attatched&quot;)

# Close the connection to the server:
connection.close()


EOF
                </code>
            </pre>
        </div>
    </div>





    



                    <div class="row pt-5">
                        <h4 id="ksovirtaddnic">
                            <a href="#ksovirtaddnic">
                                <strong>Step 13.4 -</strong> KS oVirt Add NIC
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
export PATH=~/ks_ovirt_py_venv/bin:$PATH
python3 &lt;&lt;&quot;EOF&quot;
import logging
import time
import sys
import ovirtsdk4 as sdk
import ovirtsdk4.types as types
logging.basicConfig(stream=sys.stdout, level=logging.INFO)
logger = logging.getLogger(&quot;Attune&quot;)
# This example will connect to the server and create a new virtual machine:
# Create the connection to the server:
connection = sdk.Connection(
    url=&#x27;https://{ovirtEngineServer.fqn}/ovirt-engine/api&#x27;,
    username=&#x27;{ovirtEngineApiUser.user}&#x27;,
    password=&#x27;{ovirtEngineApiUser.password}&#x27;,
    insecure=True,
    debug=True,
    log=logger,
)
logger.info(&quot;Connection Successful&quot;)
# Find the service that manages VMs:
logger.info(&quot;Getting system_service&quot;)
system_service = connection.system_service()
logger.info(&quot;Getting vms_service&quot;)
vms_service = system_service.vms_service()
# Find the VM:
logger.info(&quot;Searchig for VM &#x27;name={targetServer.fqn}&#x27;&quot;)
vm = vms_service.list(search=&#x27;name={targetServer.fqn}&#x27;)[0]
# In order to specify the network that the new interface will be
# connected to we need to specify the identifier of the virtual network
# interface profile, so we need to find it. We can have duplicate names
# for vnic profiles in different clusters, so we must also find first the
# network by datacenter and cluster:
logger.info(&quot;Getting Cluster Service&quot;)
cluster = system_service.clusters_service().cluster_service(vm.cluster.id).get()
logger.info(&quot;Getting Data Centers Service&quot;)
dcs_service = connection.system_service().data_centers_service()
logger.info(&quot;Finding Data Center n.name == &#x27;{ovirtDatacenterName}&#x27;&quot;)
dc = next(
    (n for n in dcs_service.list(search=&#x27;Clusters.name=%s&#x27; % cluster.name)
     if n.name == &#x27;{ovirtDatacenterName}&#x27;),
    None
)
if not dc:
    logger.error(&quot;Failed to find data center&quot;)
    exit(1)
logger.info(&quot;Getting Networks Service&quot;)
networks_service = dcs_service.service(dc.id).networks_service()
logger.info(&quot;Finding Network n.name == &#x27;{ovirtNetworkName}&#x27;&quot;)
network = next(
    (n for n in networks_service.list()
     if n.name == &#x27;{ovirtNetworkName}&#x27;),
    None
)
if not network:
    logger.error(&quot;Failed to find network&quot;)
    exit(1)
logger.info(&quot;Getting Profiles Service&quot;)
profiles_service = connection.system_service().vnic_profiles_service()
logger.info(&quot;Finding Profile profile.name == &#x27;{ovirtNetworkName}&#x27;&quot;)
profiles = [
    p for p in profiles_service.list() 
    if p.name == &#x27;{ovirtNetworkName}&#x27; and p.network.id == network.id
]
if profiles and len(profiles) != 1:
    logger.error(&quot;Failed to find exactly one network profile, found %s&quot;, 
        len(profiles))
    exit(1)
    
profile = profiles[0]
    
# Locate the service that manages the network interface cards of the
# virtual machine:
logger.info(&quot;Getting NICs Service&quot;)
nics_service = vms_service.vm_service(vm.id).nics_service()
# Use the &quot;add&quot; method of the network interface cards service to add the
# new network interface card:
logger.info(&quot;Adding NIC name=&#x27;vnet0&#x27;&quot;)
nics_service.add(
    types.Nic(
        name=&#x27;vnet0&#x27;,
        description=&#x27;{targetServer.fqn}-vnet0&#x27;,
        interface=types.NicInterface.{oVirtNicInterface},
        vnic_profile=types.VnicProfile(
            id=profile.id,
        ),
    ),
)
# Close the connection to the server:
connection.close()
EOF
                </code>
            </pre>
        </div>
    </div>





    



                    <div class="row pt-5">
                        <h4 id="ksovirtaddfloatingisodisk">
                            <a href="#ksovirtaddfloatingisodisk">
                                <strong>Step 13.5 -</strong> KS oVirt Add Floating ISO Disk
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
export PATH=~/ks_ovirt_py_venv/bin:$PATH

python3 &lt;&lt;&quot;EOF&quot;

import logging
import os
import time
import sys

import ovirtsdk4 as sdk
import ovirtsdk4.types as types

logging.basicConfig(stream=sys.stdout, level=logging.INFO)
logger = logging.getLogger(&quot;Attune&quot;)

# This example will connect to the server and create a new floating disk for the ISO.

# get the size of the disk required to fit the ISO.
os.chdir(&quot;{ksVmwareAttuneBaseDir}&quot;)
cwd = os.getcwd()

diskName=&#x27;kickstart_{targetServer.fqn}.iso&#x27;
# Add 1kB buffer to disk, disk_size is in bytes
disk_size = os.path.getsize(diskName) + 1024*1024

# Create the connection to the server:
connection = sdk.Connection(
    url=&#x27;https://{ovirtEngineServer.fqn}/ovirt-engine/api&#x27;,
    username=&#x27;{ovirtEngineApiUser.user}&#x27;,
    password=&#x27;{ovirtEngineApiUser.password}&#x27;,
    insecure=True,
    debug=True,
    log=logger,
)
logger.info(&quot;Connection Successful&quot;)

logger.info(&quot;Getting system_service&quot;)
system_service = connection.system_service()

logger.info(&quot;Getting the disks service&quot;)
disks_service = system_service.disks_service()
  
logger.info(&quot;CREATING disk %s&quot;, diskName)

disk = disks_service.add(
    types.Disk(
        name=diskName,
        description=diskName,
        format=types.DiskFormat.RAW,
        provisioned_size=disk_size,
        storage_domains=[
            types.StorageDomain(
                name=&#x27;{ovirtDiskStorageName}&#x27;,
            ),
        ],
        content_type=types.DiskContentType.ISO,
        storage_type=types.DiskStorageType.IMAGE
    )
)

logger.info(&quot;Getting the disk service for the new disk&quot;)
disk_service = disks_service.disk_service(disk.id)

logger.info(&quot;Starting to wait for disk to become online&quot;)
while True:
    logger.info(&quot;Wait for disk to become online [disk.status=%s]&quot; % disk.status)
    time.sleep(2)
    disk = disk_service.get()
    if disk.status == types.DiskStatus.OK:
        break

logger.info(&quot;Disk is online&quot;)

# Close the connection to the server:
connection.close()

EOF
                </code>
            </pre>
        </div>
    </div>





    



                    <div class="row pt-5">
                        <h4 id="ksovirtimagelotransferisotofloatingdisk">
                            <a href="#ksovirtimagelotransferisotofloatingdisk">
                                <strong>Step 13.6 -</strong> KS oVirt ImagelO Transfer ISO To Floating Disk
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
export PATH=&quot;/home/attune/qemu-img-6.2/bin:$PATH&quot;
export PATH=~/ks_ovirt_py_venv/bin:$PATH

python3 &lt;&lt;&quot;EOF&quot;

import logging
import time
import sys

import ovirt_imageio
from ovirt_imageio import client

import ovirtsdk4 as sdk
import ovirtsdk4.types as types

import os

logging.basicConfig(stream=sys.stdout, level=logging.INFO)
logger = logging.getLogger(&quot;Attune&quot;)

# This example will connect to the server and transfer the ISO

# Create the connection to the server:
connection = sdk.Connection(
    url=&#x27;https://{ovirtEngineServer.fqn}/ovirt-engine/api&#x27;,
    username=&#x27;{ovirtEngineApiUser.user}&#x27;,
    password=&#x27;{ovirtEngineApiUser.password}&#x27;,
    insecure=True,
    debug=True,
    log=logger,
)
logger.info(&quot;Connection Successful&quot;)

logger.info(&quot;Getting system_service&quot;)
system_service = connection.system_service()

logger.info(&quot;Getting the disks service for the new disk&quot;)
disks_service = system_service.disks_service()

diskName=&#x27;kickstart_{targetServer.fqn}.iso&#x27;
search_string=&quot;name=%s&quot; % diskName

logger.info(&quot;Getting the disks service for the new disk&quot;)
disks_service = system_service.disks_service()
disks = disks_service.list(search=search_string)

if len(disks) == 0:
    logger.info(&quot;No ISO disks found&quot;)
    exit(1)
    
disk_to_use = disks[0]

os.chdir(&quot;kickstart&quot;)

# client.upload() constant parameters
cafile=None
secure=False

# The disk name and the ISO to upload are named the same
iso_to_upload = diskName

transfers_service = system_service.image_transfers_service()

if disk_to_use.status == types.DiskStatus.LOCKED:
    logger.info(&quot;Disk %s is locked&quot; % disk_to_use.name)
    exit(1)
    

image_transfer_service = transfers_service.add(
    types.ImageTransfer(
        disk=types.Disk(
            id=disk_to_use.id
        )
    )
)

image_transfer_service2 = transfers_service.image_transfer_service(image_transfer_service.id)

while image_transfer_service.phase == types.ImageTransferPhase.INITIALIZING:
    logger.info(&quot;waiting for image transfer to pass phase INITIALIZING&quot;)
    time.sleep(1)
    image_transfer_service = image_transfer_service2.get()

logger.info(&quot;image_transfer_service transfer_url=%s, proxy_url=%s&quot; % (image_transfer_service.transfer_url, image_transfer_service.proxy_url))

client.upload(iso_to_upload, image_transfer_service.transfer_url, cafile, secure=secure)

image_transfer_service2.finalize()

while image_transfer_service.phase == types.ImageTransferPhase.TRANSFERRING:
    logger.info(&quot;image_transfer_service.phase = %s&quot; % image_transfer_service.phase)
    time.sleep(1)
    image_transfer_service = image_transfer_service2.get()

while image_transfer_service.phase == types.ImageTransferPhase.FINALIZING_SUCCESS:
    logger.info(&quot;image_transfer_service.phase = %s&quot; % image_transfer_service.phase)
    time.sleep(1)
    image_transfer_service = image_transfer_service2.get()

logger.info(&quot;image_transfer_service.phase = %s&quot; % image_transfer_service.phase)

if image_transfer_service.phase == types.ImageTransferPhase.FINISHED_SUCCESS:
    logger.info(&quot;Image transfer session was successfully closed, and the targeted image was verified and ready to be used.&quot;)
else:
    logger.info(&quot;Image transfer failure&quot;)

# Close the connection to the server:
connection.close()

EOF
                </code>
            </pre>
        </div>
    </div>





    



                    <div class="row pt-5">
                        <h4 id="ksovirtloaddatastorageisointovm">
                            <a href="#ksovirtloaddatastorageisointovm">
                                <strong>Step 13.7 -</strong> KS oVirt Load Data Storage ISO into VM
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
export PATH=~/ks_ovirt_py_venv/bin:$PATH

python3 &lt;&lt;&quot;EOF&quot;
import logging
import sys

import ovirtsdk4 as sdk
import ovirtsdk4.types as types

logging.basicConfig(stream=sys.stdout, level=logging.INFO)
logger = logging.getLogger(&quot;Attune&quot;)

# This example will connect to the server, search for a VM by name and
# remove it:

# Create the connection to the server:
connection = sdk.Connection(
    url=&#x27;https://{ovirtEngineServer.fqn}/ovirt-engine/api&#x27;,
    username=&#x27;{ovirtEngineApiUser.user}&#x27;,
    password=&#x27;{ovirtEngineApiUser.password}&#x27;,
    insecure=True,
    debug=True,
    log=logger,
)
logger.info(&quot;Connection Successful&quot;)

logger.info(&quot;Getting system_service&quot;)
system_service = connection.system_service()

logger.info(&quot;Getting vms_service&quot;)
vms_service = system_service.vms_service()

# Find the VM:
logger.info(&quot;Searchig for VM &#x27;name={targetServer.fqn}&#x27;&quot;)
vm = vms_service.list(search=&#x27;name={targetServer.fqn}&#x27;)[0]

logger.info(&quot;Getting storage_domains_services&quot;)
sds_service = system_service.storage_domains_service()

logger.info(&quot;Getting storage_domains for &#x27;name={ovirtDiskStorageName}&#x27;&quot;)
storage_domain = sds_service.list(search=&#x27;name={ovirtDiskStorageName}&#x27;)[0]

print(&quot;storage_domain = %s, id=%s&quot; % (storage_domain, storage_domain.id))

logger.info(&quot;Getting storage_domains_service for &#x27;name={ovirtDiskStorageName}&#x27;&quot;)
storage_domain_service = sds_service.storage_domain_service(storage_domain.id)

logger.info(&quot;Getting VM Service for VM ID=%s&quot; % vm.id)
vm_service = vms_service.vm_service(vm.id)

logger.info(&quot;Get the CDROMS Service&quot;)
cdroms_service = vm_service.cdroms_service()

logger.info(&quot;Get the first CDROM&quot;)
cdrom = cdroms_service.list()[0]

logger.info(&quot;Get the CDROM service for the first drive&quot;)
cdrom_service = cdroms_service.cdrom_service(cdrom.id)

# Find the ISO disk to attach as CD ROM
diskName=&#x27;kickstart_{targetServer.fqn}.iso&#x27;

search_string=&quot;name=%s&quot; % diskName

logger.info(&quot;Getting the disks service&quot;)
disks_service = system_service.disks_service()
disks = disks_service.list(search=search_string)

if len(disks) == 0:
    logger.info(&quot;No ISO disks found&quot;)
    exit(1)
else:
    disk_to_use = disks[0]
    print(&quot;disk_to_use.id=%s&quot; % disk_to_use.id)

    logger.info(&quot;Attach the CDROM&quot;)
    cdrom_service.update(
        cdrom=types.Cdrom(
            file=types.File(
                id=disk_to_use.id
            ),
        ),
        current=False,
    )

logger.info(&quot;Close the connection to the server&quot;)
connection.close()

EOF
                </code>
            </pre>
        </div>
    </div>





    



                    <div class="row pt-5">
                        <h4 id="ksovirtboottoiso">
                            <a href="#ksovirtboottoiso">
                                <strong>Step 13.8 -</strong> KS oVirt Boot to ISO
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
export PATH=~/ks_ovirt_py_venv/bin:$PATH

python3 &lt;&lt;&quot;EOF&quot;
import logging
import time
import sys

import ovirtsdk4 as sdk
import ovirtsdk4.types as types

logging.basicConfig(stream=sys.stdout, level=logging.INFO)
logger = logging.getLogger(&quot;Attune&quot;)

# This example will connect to the server and create a new virtual machine:

# Create the connection to the server:
connection = sdk.Connection(
    url=&#x27;https://{ovirtEngineServer.fqn}/ovirt-engine/api&#x27;,
    username=&#x27;{ovirtEngineApiUser.user}&#x27;,
    password=&#x27;{ovirtEngineApiUser.password}&#x27;,
    insecure=True,
    debug=True,
    log=logger,
)
logger.info(&quot;Connection Successful&quot;)

# Find the service that manages VMs:
logger.info(&quot;Getting system_service&quot;)
system_service = connection.system_service()

logger.info(&quot;Getting vms_service&quot;)
vms_service = system_service.vms_service()

logger.info(&quot;Searchig for VM &#x27;name={targetServer.fqn}&#x27;&quot;)
vm = vms_service.list(search=&#x27;name={targetServer.fqn}&#x27;)[0]

logger.info(&quot;Getting VM Service for VM ID=%s&quot; % vm.id)
vm_service = vms_service.vm_service(vm.id)

logger.info(&quot;Booting VM to CDROM&quot;)
vm_service.start(
    volatile=True,
    vm=types.Vm(
        os=types.OperatingSystem(
            boot=types.Boot(
                devices=[
                    types.BootDevice.CDROM
                ]
            )
        )
    )
)

# additional documentation about attributes and types that can be changed:
# https://your.rhv.host/ovirt-engine/api/model#types/vm
# https://your.rhv.host/ovirt-engine/api/model#types/operating_system
# https://your.rhv.host/ovirt-engine/api/model#types/boot
# https://your.rhv.host/ovirt-engine/api/model#types/boot_device


# Wait till the virtual machine is up:
while True:
    time.sleep(5)
    vm = vm_service.get()
    if vm.status == types.VmStatus.UP:
        break

# Close the connection to the server:
connection.close()


EOF
                </code>
            </pre>
        </div>
    </div>






        



                    <div class="row pt-5">
                        <h4 id="kswinwinrmhttpswait120s">
                            <a href="#kswinwinrmhttpswait120s">
                                <strong>Step 14 -</strong> KS Win WinRM HTTPS Wait 120s
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>












    

    <div class="row">
        <p class="mb-0">
            Check if TCP Port <strong>0</strong> is listening.
            When the TCP Port is up, wait <strong>120</strong>
            seconds.
        </p>
        <p>Use Telnet to check if the TCP Service is accepting connections.</p>
    </div>





        



                    <div class="row pt-5">
                        <h3 id="ksovirtrecreatevirtualmachinecleanup">
                            <a href="#ksovirtrecreatevirtualmachinecleanup">
                                <strong>Step 15 -</strong> KS oVirt Recreate Virtual Machine - Cleanup
                            </a>
                        </h3>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>





    




    



                    <div class="row pt-5">
                        <h4 id="ksovirtunloadisofromvm">
                            <a href="#ksovirtunloadisofromvm">
                                <strong>Step 15.1 -</strong> KS oVirt Unload ISO from VM
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>










                        <div class="row">
                            <p>
                                Connect via ssh:
                            </p>
                        </div>
                        <div class="row py-1">
                            <code class="language-sql">
ssh {linuxattuneuser}@{attuneosbuildserver}
                            </code>
                        </div>



    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
export PATH=~/ks_ovirt_py_venv/bin:$PATH

python3 &lt;&lt;&quot;EOF&quot;
import logging
import sys

import ovirtsdk4 as sdk
import ovirtsdk4.types as types

logging.basicConfig(stream=sys.stdout, level=logging.INFO)
logger = logging.getLogger(&quot;Attune&quot;)

# This example will connect to the server, search for a VM by name and
# remove it:

# Create the connection to the server:
connection = sdk.Connection(
    url=&#x27;https://{ovirtEngineServer.fqn}/ovirt-engine/api&#x27;,
    username=&#x27;{ovirtEngineApiUser.user}&#x27;,
    password=&#x27;{ovirtEngineApiUser.password}&#x27;,
    insecure=True,
    debug=True,
    log=logger,
)
logger.info(&quot;Connection Successful&quot;)

logger.info(&quot;Getting system_service&quot;)
system_service = connection.system_service()

logger.info(&quot;Getting vms_service&quot;)
vms_service = system_service.vms_service()

# Find the VM:
logger.info(&quot;Searchig for VM &#x27;name={targetServer.fqn}&#x27;&quot;)
vmSearch = vms_service.list(search=&#x27;name={targetServer.fqn}&#x27;)

if not len(vmSearch):
    logger.info(&quot;VM &#x27;name={targetServer.fqn}&#x27; doesn&#x27;t exist, exiting&quot;)
    exit(0)

logger.info(&quot;Found VM &#x27;name={targetServer.fqn}&#x27;&quot;)
vm = vmSearch[0]

logger.info(&quot;Getting VM Service for VM ID=%s&quot; % vm.id)
vm_service = vms_service.vm_service(vm.id)

logger.info(&quot;Get the CDROMS Service&quot;)
cdroms_service = vm_service.cdroms_service()

logger.info(&quot;Get the first CDROM&quot;)
cdrom = cdroms_service.list()[0]

logger.info(&quot;Get the CDROM service for the first drive&quot;)
cdrom_service = cdroms_service.cdrom_service(cdrom.id)


logger.info(&quot;Eject the CDROM on PowerOn&quot;)
cdrom_service.update(
    cdrom=types.Cdrom(
        file=types.File(
            id=&#x27;&#x27;
        ),
    ),
    current=False,
)


logger.info(&quot;Close the connection to the server&quot;)
connection.close()

EOF
                </code>
            </pre>
        </div>
    </div>





    



                    <div class="row pt-5">
                        <h4 id="ksovirtdeletefloatingisodisk">
                            <a href="#ksovirtdeletefloatingisodisk">
                                <strong>Step 15.2 -</strong> KS oVirt Delete Floating ISO Disk
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
export PATH=~/ks_ovirt_py_venv/bin:$PATH

python3 &lt;&lt;&quot;EOF&quot;

import logging
import time
import sys

import ovirt_imageio
from ovirt_imageio import client

import ovirtsdk4 as sdk
import ovirtsdk4.types as types

import os

logging.basicConfig(stream=sys.stdout, level=logging.INFO)
logger = logging.getLogger(&quot;Attune&quot;)

# This example will connect to the server and transfer the ISO

# Create the connection to the server:
connection = sdk.Connection(
    url=&#x27;https://{ovirtEngineServer.fqn}/ovirt-engine/api&#x27;,
    username=&#x27;{ovirtEngineApiUser.user}&#x27;,
    password=&#x27;{ovirtEngineApiUser.password}&#x27;,
    insecure=True,
    debug=True,
    log=logger,
)
logger.info(&quot;Connection Successful&quot;)

logger.info(&quot;Getting system_service&quot;)
system_service = connection.system_service()

logger.info(&quot;Getting vms_service&quot;)
vms_service = system_service.vms_service()

logger.info(&quot;Getting the disks service for the new disk&quot;)
disks_service = system_service.disks_service()

logger.info(&quot;Searchig for VM &#x27;name={targetServer.fqn}&#x27;&quot;)
vmSearch = vms_service.list(search=&#x27;name={targetServer.fqn}&#x27;)

if not len(vmSearch):
    logger.info(&quot;VM &#x27;name={targetServer.fqn}&#x27; doesn&#x27;t exist, exiting&quot;)
    exit(0)

logger.info(&quot;Found VM &#x27;name={targetServer.fqn}&#x27;&quot;)
vm = vmSearch[0]


diskName=&#x27;kickstart_{targetServer.fqn}.iso&#x27;

search_string=&quot;name=%s&quot; % diskName
print(&quot;search_string=%s&quot; % search_string)

logger.info(&quot;Getting the disks service for the new disk&quot;)
disks_service = system_service.disks_service()
disks = disks_service.list(search=search_string)


if not len(disks):
    logger.info(&quot;%s is already deleted.&quot; % diskName)

for disk in disks:
    logger.info(&quot;deleteing disk = %s, id=%s, status=%s&quot; % (disk.name, disk.id, disk.status))
    disk_service = disks_service.disk_service(disk.id)
    disk_service.remove()

EOF
                </code>
            </pre>
        </div>
    </div>






        



                    <div class="row pt-5">
                        <h4 id="kscleanbuildfiles">
                            <a href="#kscleanbuildfiles">
                                <strong>Step 16 -</strong> KS Clean Build Files
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
DIR=&quot;{ksVmwareAttuneBaseDir}/build-{targetServer.fqn}&quot;
[[ -d ${DIR} ]] &amp;&amp; rm -rf ${DIR} &amp;&amp; echo &quot;Removed ${DIR}&quot; || \
    echo &quot;No directory to remove.&quot;

ISO=&quot;{ksVmwareAttuneBaseDir}/kickstart_{targetServer.fqn}.iso&quot;
[[ -f ${ISO} ]] &amp;&amp; rm -fv ${ISO} || echo &quot;No ISO to remove.&quot;
                </code>
            </pre>
        </div>
    </div>





        



                    <div class="row pt-5">
                        <h4 id="installovirtguestadditionslink">
                            <a href="#installovirtguestadditionslink">
                                <strong>Step 17 -</strong> Install oVirt Guest Additions (Link)
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>






    






                    <div class="row pt-5">
                        <div class="col">
                            <h3>Completed</h3>
                            <p>
                                You have completed this instruction.
                            </p>
                        </div>
                    </div>
                </div>
            </div>

<!-- Download Attune Ad -->

            <div class="col-lg-2 px-0">
                <div class="container px-0 pt-3 pl-5 sticky-top">
                    <div class="card border-light mb-3" style="max-width: 18rem;">
                        <div class="card-body attune-ad">
                            <img
                                src="https://www.servertribe.com/wp-content/uploads/2022/06/AttuneLogoV2_powered_by.png"
                                alt="Attune - Powered by ServerTribe"
                                class="img-fluid">
                            <h5 class="card-title mt-3 text-center">
                                Automate with Attune
                            </h5>
                            <p class="card-text text-left">
                                Download the Attune Community Edition.
                            </p>
                            <p class="text-center">
                                <a href="https://www.servertribe.com/download-attune-registration/"
                                   class="btn btn-primary mt-3">
                                    DOWNLOAD!!!
                                </a>
                            </p>
                        </div>
                    </div>
                </div>
            </div>

        </div>

<!-- Join Discord -->

        <div class="row py-5">
            <div class="jumbotron">
                <h1 class="display-4 text-center">
                    Discuss this Instruction in Discord
                </h1>
                <p class="lead">

                    Join our Discord channel and connect with like-minded
                    individuals who
                    share your passion. Engage in lively discussions, gain
                    valuable insights,
                    and stay updated on the latest trends in our industry. Don't
                    miss out on
                    this opportunity to network, learn, and grow together.
                </p>
                <hr class="my-4 text-center">
                <div class="col px-0">
                    <p class="text-center">
                        Click the link below and become a part of our vibrant
                        community on
                        Discord today!
                    </p>
                    <p class="lead text-center">
                        <a class="btn btn-primary btn-lg"
                           href="https://discord.com/invite/3YpJsagqUn"
                           role="button">
                            Join NOW!!!
                        </a>
                    </p>
                </div>
            </div>
        </div>

    </div>
</div>


<script src="https://code.jquery.com/jquery-3.2.1.slim.min.js"
        integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN"
        crossorigin="anonymous"></script>
<script
    src="https://cdn.jsdelivr.net/npm/popper.js@1.12.9/dist/umd/popper.min.js"
    integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q"
    crossorigin="anonymous"></script>
<script
    src="https://cdn.jsdelivr.net/npm/bootstrap@4.0.0/dist/js/bootstrap.min.js"
    integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl"
    crossorigin="anonymous"></script>

<script
    src="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/js/all.min.js"></script>

<script
    src="https://cdnjs.cloudflare.com/ajax/libs/prism/1.29.0/components/prism-core.min.js"></script>
<script
    src="https://cdnjs.cloudflare.com/ajax/libs/prism/1.29.0/plugins/autoloader/prism-autoloader.min.js"></script>


</body>
</html>
